/*
Copyright 2002 Steve Jolly

This file is part of Scot

Scot is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; specifically version 2 of the License.

Scot is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Scot; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

import org.jibble.pircbot.*;
import java.sql.*;

public class Scot extends PircBot {

    public String ServerName;
    public int ServerPort;
    public String ServerPassword;
    public String ChannelName;
    public String BotName;

    public static String DBHost = new String("localhost");
    public static String DBName = new String("scot");
    public static String DBUserName = new String("scotbot");
    public static String DBPassword = new String("insert_your_password_here");

    public java.util.Random ran = new java.util.Random();

    public Scot(String CServerName, int CServerPort, String CServerPassword, String CChannelName, String CBotName) {
		ServerName=CServerName;
		ServerPort=CServerPort;
		ServerPassword=CServerPassword;
		ChannelName=CChannelName;
		BotName=CBotName;
		this.setName(BotName);
		this.setLogin(BotName);
    }

    public void onMessage(String channel, String sender, String login, String hostname, String message) {
		IRCLine m = new IRCLine(message);
		m.checkAddressed(BotName);
		publicMessageHandler(channel, sender, login, hostname, m);
    }

    public void onPrivateMessage(String sender, String login, String hostname, String message) {
		IRCLine m = new IRCLine(message);
		m.checkAddressed(BotName);
		m.addressed = true;	//it's a private message, right?
		if (!privateMessageHandler(sender, login, hostname, m)) sendMessage(sender, sender+": lotus petals fall; samurai inscrutable; that command isn't");
    }

    private boolean generalMessageHandler(String channel, String sender, String login, String hostname, IRCLine m) {
		Connection Con;
		boolean validCommand=false;
		if ((m.addressed)&&(m.size()>0)) {
		    EscapedString escapedSender = new EscapedString(sender);
		    Con=DBOpen(channel);
		    System.out.println(m.toString());
		    if (m.starts("latest")) {
				String Query=null;
				m.remove(0);
				switch (m.size()) {
				case 0:
				    Query = new String("select * from scribot order by timestamp desc limit 1;");
				    break;
				case 1:
				    EscapedString commenter = new EscapedString(m.toString());
				    Query = new String("select * from scribot where commenter='"+commenter.toString()+"' order by timestamp desc limit 1;");
				    break;
				default:
				    sendMessage(channel, sender+": sorry - invalid syntax!");
				    break;
				}
				System.out.println(Query);
				if (Query!=null) try {
				    ResultSet rs=DBQuery(Con, Query, channel);
				    if (rs.next()) { //if the query returned a result, ie if there is a database entry for the given commenter (if any)
						Timestamp ts=rs.getTimestamp(1);
						String comment=rs.getString(2);
						String commenter=rs.getString(3);
						sendMessage(channel, commenter+" said '"+comment+"'");
				    } else {
						sendMessage(channel, sender+": sorry - couldn't find anything...");
				    }
				} catch (Exception e) {
				    sendMessage(channel, "error extracting results from query");
				}
				validCommand=true;
		    }
		    else if (m.starts("search")) {
		        m.remove(0);
			if (m.size()>0) {
			    EscapedString searchTerm = new EscapedString(m.toString().toLowerCase());
			    String Query = new String("select * from scribot where instr(LCASE(comment),'"+searchTerm.toString()+"') order by timestamp desc limit 1;");
			    try {
					ResultSet rs=DBQuery(Con, Query, channel);
					if (rs.next()) { //if the query returned a result, ie if there's a match for that search term
					    Timestamp ts=rs.getTimestamp(1);
				   		String comment=rs.getString(2);
						    String commenter=rs.getString(3);
						    sendMessage(channel, commenter+" said '"+comment+"'");
						} else {
						    sendMessage(channel, sender+": sorry - no matches for '"+m.toString()+"'");
						}
				    } catch (Exception e) {
						sendMessage(channel, "error extracting results from query");
				    }
				} else {
				    sendMessage(channel, sender+": you have to tell me what to search for");
				}
				validCommand=true;
		    } else if (m.starts("help")) {
				m.remove(0);
				if (m.size()==0) {
				    sendMessage(channel, sender+": syntax is '"+BotName+": [command] [parameters]. Available commands are add, correction, latest and search.  Try 'help [command]' for details");
				} else if (m.starts("add")) {
				    sendMessage(channel, sender+": 'add' adds an entry to the database, usually of the form 'http://an.interesting.link # a description of the link'. If you start your submission with 'http' then the 'add' is optional.");
				} else if (m.starts("correction")) {
				    sendMessage(channel, sender+": 'correction' replaces the most recent entry that *you* added to the database with whatever you pass as a parameter (see 'help add' for typical format details)");
				} else if (m.starts("latest")) {
				    sendMessage(channel, sender+": 'latest' returns the most recent link added to the database. 'latest name' returns the most recent link added by 'name'");
				} else if (m.starts("search")) {
				    sendMessage(channel, sender+": 'search' returns the most recent link added to the database that contains the given text.  The search performed is a case-insensitive substring match.  If you want something better, use the web interface :)");
				} else {
				    sendMessage(channel, sender+": sorry - no help is available for that command");
				}
		        validCommand=true;
		    }
		}
		return validCommand;
    }

    private boolean publicMessageHandler(String channel, String sender, String login, String hostname, IRCLine m) {
		Connection Con;
		boolean validCommand=false;
		if ((m.addressed)&&(m.size()>0)) {
		    EscapedString escapedSender = new EscapedString(sender);
			Con=DBOpen(channel);
//			System.out.println(m.toString());
			if ((m.starts("add"))||(((String)m.elementAt(0)).startsWith("http"))) {
				if (m.starts("add")) m.remove(0);
				EscapedString escapedMessage = new EscapedString(m.toString());
				String Query = new String("INSERT INTO scribot (comment,commenter) VALUES('"+escapedMessage.toString()+"','"+escapedSender.toString()+"');");
				ResultSet rs=DBQuery(Con, Query, channel);
				sendMessage(sender, "added "+m.toString());
				validCommand=true;
		    }
		    else if (m.starts("correction")) {
				m.remove(0);
				EscapedString escapedMessage = new EscapedString(m.toString());
				String Query = new String("select * from scribot where commenter='"+escapedSender.toString()+"' order by timestamp desc limit 1;");
				ResultSet rs=DBQuery(Con, Query, channel);
				try {
					if (rs.next()) { //if the query returned a result, ie the sender has actually added something
						Timestamp ts=rs.getTimestamp(1);
						Query = new String("update scribot set comment='"+escapedMessage+"' where timestamp='"+ts.toString()+"';");
						rs=DBQuery(Con, Query, channel);
				    } else {
						sendMessage(channel, "you haven't ever added anything, "+sender+" :)");
			    	}
				} catch (Exception e) {
				    sendMessage(channel, "error extracting results from query");
				}
				validCommand=true;
		    }
			else validCommand = generalMessageHandler(channel, sender, login, hostname, m);
        }
		return validCommand;
    }
    
    private boolean privateMessageHandler(String sender, String login, String hostname, IRCLine m) {
		boolean validCommand=false;
		Connection Con;
		if ((m.addressed)&&(m.size()>0)) {
//			EscapedString escapedSender = new EscapedString(sender);
//			Con=DBOpen(channel);
//			System.out.println(m.toString());
		    if ((m.starts("add"))||(((String)m.elementAt(0)).startsWith("http"))) {
				sendMessage(sender, "Additions must be made in public");
				validCommand=true;
		    }
		    else if (m.starts("correction")) {
				sendMessage(sender, "Corrections must be made in public");
				validCommand=true;
		    }
			else validCommand = generalMessageHandler(sender, sender, login, hostname, m);
		}
		return validCommand;
    }
    
    protected void onDisconnect () {
	int tries=0;
	while (tries<1000 && !isConnected()) {
	    try {
		connect(ServerName, ServerPort, ServerPassword);
	    }
	    catch (Exception e) {
		System.out.println("Connection attempt "+tries+" failed.");
		tries++;
		if (tries>=1000000) System.exit(0);
	    }
	} //while
	joinChannel(ChannelName);
	sendAction(ChannelName, "poings");
    }

    protected void onKick (String channel, String kickerNick, String kickerLogin, String kickerHostname, String recipientNick, String reason) {
	if (recipientNick.equals(BotName)) {
	    joinChannel(channel);
	    sendMessage(channel, "bastard");
	}
    }

    private Connection DBOpen (String channel) {
	Connection DBCon = null;
	try {
	    Class.forName("org.gjt.mm.mysql.Driver").newInstance();
	    DBCon = DriverManager.getConnection("jdbc:mysql://"+DBHost+"/"+DBName+"?user="+DBUserName+"&password="+DBPassword);
	} catch (Exception e) {
	    System.out.println("Database connection attempt failed.");
	    sendMessage(channel, "error connecting to database");
	}
	return DBCon;
    }
	
    private ResultSet DBQuery (Connection DBCon, String Query, String channel) {
	ResultSet DBrs = null;
	try {
	    Statement DBstmt = DBCon.createStatement();
	    DBrs = DBstmt.executeQuery(Query);
	} catch (Exception e) {
	    System.out.println("Query failed: "+Query.toString());
	    sendMessage(channel, "error executing query");
	}
	return DBrs;
    }
}
